import QtQuick 1.0

import quickwidgets 1.0
//import qmlprocess 1.0

Item {
    function togglePlay() {
        flipable.flipped = !flipable.flipped
    }

    function play() {
        if (!flipable.flipped) {
            flipable.flipped = !flipable.flipped
        }
    }

    function pause() {
        if (flipable.flipped) {
            flipable.flipped = !flipable.flipped
        }
     }

    id: container
    property color inactivecolor: "#64b5b5b5"
    property color activecolor: "#6427c2ff"
//    property string playimage: "/scratchbox/users/mar637/targets/FREMANTLE_ARMEL/usr/share/themes/alpha/mediaplayer/Play.png"
//    property string pauseimage: "/scratchbox/users/mar637/targets/FREMANTLE_ARMEL/usr/share/themes/alpha/mediaplayer/Pause.png"
    property string playimage: "/etc/hildon/theme/mediaplayer/Play.png"
    property string pauseimage: "/etc/hildon/theme/mediaplayer/Pause.png"
    width: 64
    height: 64
    signal pressed()

    Rectangle {
        id: button
        radius: 10
        anchors.fill: parent
        color:  container.inactivecolor
        Flipable {
            property bool flipped: false
            id: flipable
            anchors.fill: parent

            transform: Rotation {
                id: rotation
                origin.x: flipable.width/2
                origin.y: flipable.height/2
                axis.x:0; axis.y:1; axis.z:0
                angle:0

                Behavior on angle { PropertyAnimation{} }
            }

            front: Image {
                id: play
                anchors.centerIn: parent
                smooth: true
                source: container.playimage
            }


            back:
                Rectangle {
                radius: 10
                width:  container.width
                height: container.height
                anchors.centerIn: parent
                color: container.activecolor
                Image {
                    id: pause
                    anchors.centerIn: parent
                    smooth: true
                    source: container.pauseimage
                }
            }

            states: State {
                name: "pause"
                PropertyChanges { target: rotation; angle: 180 }
                when: flipable.flipped
            }

            transitions: Transition {
                NumberAnimation { target: rotation; property: "angle"; duration: 200 }
            }


        MouseArea {
            id: ma
            anchors.fill:  parent
            onClicked: {
                dbusplaypause.run()
                container.pressed()
            }
        }
        }
        Process {
             id: dbusplaypause
             command: "sh -c \"dbus-send --type=method_call --dest=ru.somebody.someplayer / ru.somebody.someplayer.toggle\""
             onCompleted: { togglePlay() }
             onFailed: { button.color = "red"; }
        }
    }
}
